#include <conio.h>
#include <stdio.h>
#include <math.h>

#include "add.h"
//*********************************************
// je treba nejprve nastavit y[0],z[0],u[0];
//*********************************************

//----------------------------------------------------------------------
// kontrola ukonceni vypoctu
// num_less hodnot mensich nez EPS
// 1 pokud tri posledni hodnoty mensi EPS
int compare_EPS(double X[], int n)
{
//  printf("Test EPS :n=%d\n",n);
  int result=1,i=0;
  if (n<num_less) return 0;
  while (i<num_less && result)
  {
     result = fabs(X[n-i])<EPS;
     i++;
  }
  return result;
}

//-------------------------------------------------------------------
// hlavni vypocet
void vypocet()
{
  int i=0;    // ridici promenna pro vysledky y,z,u
  double t=T0;
  while (t<TMAX-h)
  {
//     printf("DY[0]=y[%d]=%g\n",i,y[i]);
     DY[0]=y[i];
     DZ[0]=z[i];
     DU[0]=u[i];
     partial();
     y[i+1] = y[i] + vysl_DY;
     z[i+1] = z[i] + vysl_DZ;
     u[i+1] = u[i] + vysl_DU;
     i++;
     for (int pom=0;pom<MAX_ORD;pom++)
     {
       DY[pom]=0;
       DZ[pom]=0;
       DU[pom]=0;
     }
     vysl_DY=0;
     vysl_DZ=0;
     vysl_DU=0;
     t+=h;
  }
}

//------------------------------------------------------------------
// vypocet DY,DZ, DU
void partial()
{
  int i=0;
  while (i<MAX_ORD && !compare_EPS(DY,i) && !compare_EPS(DZ,i)
	 && !compare_EPS(DU,i))
  {
      DY[i+1]=(h/(double)(i+1))*DZ[i];
      DZ[i+1]=(h/(double)(i+1))*(-DZ[i]-DU[i]);
      DU[i+1]=(h/(double)(i+1))*(-DU[i]+DZ[i]);
      i++;
      vysl_DY+=DY[i];
      vysl_DZ+=DZ[i];
      vysl_DU+=DU[i];
  }
}

//----------------------------------------------------------------
//----------------------------------------------------------------
//------------------- M A I N ------------------------------------

int main()
{
 y[0]=1; z[0]=1; u[0]=0;     // nastaveni pocatecnich podminek
 // zadani: y'=e^-t * cos t  y(0)=1; dt=0.1, TMAX=1

 clrscr();


 vypocet();
   printf("t              y              z            u\n");

 for (int i=0; i<N;i++)
   printf("%2d         %.10g     %.10g    %.10g\n",i,y[i],z[i],u[i]);

 printf("=========================================================\n");

 return 0;
}

// konec add.cpp